m = 2; % pendulum mass
alpha = 10; % m+M pendulum and cart mass
L = 0.5; % pendulum half-length
D = 2;  % axis length
kl = 10000; % left spring stiffness
kr = 10000; % right spring stiffness
dl = 0.1; % left spring length
dr = 0.1; % right spring length
g = 9.81; % gravity constant
dt = 0.1;

T = 150;
s = zeros(4,T+1);
s(:,1) = [0.5 ; 0.0 ; 0.3 ; 0.0];
a = zeros(1,T);
a(1:3) = 40;
for t=1:T
    [s2 r] = pendulum_step(s(:,t), a(t), dt);
    s(:,t+1) = s2;
    figure(1);
    clf;
    axis([-2*L D+2*L -2*L  2*L]);
    line([0,0,D,D],[0.05,0,0,0.05]);
    line([s(1,t)-0.03, s(1,t)-0.03, s(1,t)+0.03, s(1,t)+0.03, s(1,t)-0.03], [0.03, -0.03, -0.03, 0.03, 0.03]);
    line([s(1,t), s(1,t)-2*L*sin(s(3,t))], [0, 2*L*cos(s(3,t))]);
    pause(dt);
end

s1 = [0.6; 0; 0.4; 0.6];
while(true)
    [s2 r] = pendulum_step(s1, 0, dt);
    s1 = s2;
    figure(1);
    clf;
    axis([-2*L D+2*L -2*L  2*L]);
    line([0,0,D,D],[0.05,0,0,0.05]);
    line([s1(1)-0.03, s1(1)-0.03, s1(1)+0.03, s1(1)+0.03, s1(1)-0.03], [0.03, -0.03, -0.03, 0.03, 0.03]);
    line([s1(1), s1(1)-2*L*sin(s1(3))], [0, 2*L*cos(s1(3))]);
    pause(dt);
end
